----------------------------------------------
-- Serial Test Direct!!
---------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity SER_SIM is

end SER_SIM;

architecture ARC of SER_SIM is

    component SERIAL
        port(CLK : in std_logic;
        RESET : in std_logic;
        --ADM
        RxD : in std_logic;
        TxD : out std_logic;
        --CPU
	   RS : out std_logic_vector(3 downto 0);
        DO : in std_logic;                              -- When Start 1
        WR : in std_logic;                              -- W = '1' R = '0'
        WD : in std_logic_vector(7 downto 0);
        RD : out std_logic_vector(7 downto 0);
        VALID : out std_logic;
	   BUSY : out std_logic
    );
    end component;

    component SERIAL_DATA
        port(RxD : out std_logic);
    end component;

    signal CLK : std_logic;
    signal LED : std_logic_vector(7 downto 0);
    signal TxD : std_logic;
    signal RxD : std_logic;
    signal RESET : std_logic := '1';

    signal RSTATE : std_logic_vector(3 downto 0);
    signal START : std_logic;
    signal WRMODE : std_logic;
    signal WDATA : std_logic_vector(7 downto 0);
    signal RDATA : std_logic_vector(7 downto 0);
    signal VAL : std_logic;
    signal BUSY : std_logic;

begin

   RESET <= '0';

    SERIAL_INST : SERIAL port map(
        CLK => CLK,
        RESET => RESET,
        RxD => RxD,
        TxD => TxD,
        RS =>RSTATE,
        DO => START,
        WR => WRMODE,
        WD => WDATA,
        RD => RDATA,
        VALID => VAL,
        BUSY => BUSY
        );

    SDINST : SERIAL_DATA port map(
        RxD => RxD
    );

    process
    begin
        wait for 20 ns;
        CLK <= '0';
        wait for 20 ns;
        CLK <= '1';
        wait until CLK = '1';
    end process;

end ARC;

